// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from smacc2_msgs:msg/SmaccState.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_state__rosidl_typesupport_fastrtps_cpp.hpp"
#include "smacc2_msgs/msg/detail/smacc_state__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace smacc2_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const smacc2_msgs::msg::SmaccTransition &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  smacc2_msgs::msg::SmaccTransition &);
size_t get_serialized_size(
  const smacc2_msgs::msg::SmaccTransition &,
  size_t current_alignment);
size_t
max_serialized_size_SmaccTransition(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace smacc2_msgs

namespace smacc2_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const smacc2_msgs::msg::SmaccOrthogonal &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  smacc2_msgs::msg::SmaccOrthogonal &);
size_t get_serialized_size(
  const smacc2_msgs::msg::SmaccOrthogonal &,
  size_t current_alignment);
size_t
max_serialized_size_SmaccOrthogonal(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace smacc2_msgs

namespace smacc2_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const smacc2_msgs::msg::SmaccStateReactor &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  smacc2_msgs::msg::SmaccStateReactor &);
size_t get_serialized_size(
  const smacc2_msgs::msg::SmaccStateReactor &,
  size_t current_alignment);
size_t
max_serialized_size_SmaccStateReactor(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace smacc2_msgs

namespace smacc2_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const smacc2_msgs::msg::SmaccEventGenerator &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  smacc2_msgs::msg::SmaccEventGenerator &);
size_t get_serialized_size(
  const smacc2_msgs::msg::SmaccEventGenerator &,
  size_t current_alignment);
size_t
max_serialized_size_SmaccEventGenerator(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace smacc2_msgs


namespace smacc2_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_smacc2_msgs
cdr_serialize(
  const smacc2_msgs::msg::SmaccState & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: index
  cdr << ros_message.index;
  // Member: name
  cdr << ros_message.name;
  // Member: children_states
  {
    cdr << ros_message.children_states;
  }
  // Member: level
  cdr << ros_message.level;
  // Member: transitions
  {
    size_t size = ros_message.transitions.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.transitions[i],
        cdr);
    }
  }
  // Member: orthogonals
  {
    size_t size = ros_message.orthogonals.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.orthogonals[i],
        cdr);
    }
  }
  // Member: state_reactors
  {
    size_t size = ros_message.state_reactors.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.state_reactors[i],
        cdr);
    }
  }
  // Member: event_generators
  {
    size_t size = ros_message.event_generators.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.event_generators[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_smacc2_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  smacc2_msgs::msg::SmaccState & ros_message)
{
  // Member: index
  cdr >> ros_message.index;

  // Member: name
  cdr >> ros_message.name;

  // Member: children_states
  {
    cdr >> ros_message.children_states;
  }

  // Member: level
  cdr >> ros_message.level;

  // Member: transitions
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.transitions.resize(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.transitions[i]);
    }
  }

  // Member: orthogonals
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.orthogonals.resize(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.orthogonals[i]);
    }
  }

  // Member: state_reactors
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.state_reactors.resize(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.state_reactors[i]);
    }
  }

  // Member: event_generators
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.event_generators.resize(size);
    for (size_t i = 0; i < size; i++) {
      smacc2_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.event_generators[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_smacc2_msgs
get_serialized_size(
  const smacc2_msgs::msg::SmaccState & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: index
  {
    size_t item_size = sizeof(ros_message.index);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: name
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.name.size() + 1);
  // Member: children_states
  {
    size_t array_size = ros_message.children_states.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (ros_message.children_states[index].size() + 1);
    }
  }
  // Member: level
  {
    size_t item_size = sizeof(ros_message.level);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: transitions
  {
    size_t array_size = ros_message.transitions.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.transitions[index], current_alignment);
    }
  }
  // Member: orthogonals
  {
    size_t array_size = ros_message.orthogonals.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.orthogonals[index], current_alignment);
    }
  }
  // Member: state_reactors
  {
    size_t array_size = ros_message.state_reactors.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.state_reactors[index], current_alignment);
    }
  }
  // Member: event_generators
  {
    size_t array_size = ros_message.event_generators.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.event_generators[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_smacc2_msgs
max_serialized_size_SmaccState(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: index
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: name
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: children_states
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: level
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: transitions
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SmaccTransition(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: orthogonals
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SmaccOrthogonal(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: state_reactors
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SmaccStateReactor(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: event_generators
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        smacc2_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SmaccEventGenerator(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  return current_alignment - initial_alignment;
}

static bool _SmaccState__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const smacc2_msgs::msg::SmaccState *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SmaccState__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<smacc2_msgs::msg::SmaccState *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SmaccState__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const smacc2_msgs::msg::SmaccState *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SmaccState__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_SmaccState(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _SmaccState__callbacks = {
  "smacc2_msgs::msg",
  "SmaccState",
  _SmaccState__cdr_serialize,
  _SmaccState__cdr_deserialize,
  _SmaccState__get_serialized_size,
  _SmaccState__max_serialized_size
};

static rosidl_message_type_support_t _SmaccState__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SmaccState__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace smacc2_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_smacc2_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<smacc2_msgs::msg::SmaccState>()
{
  return &smacc2_msgs::msg::typesupport_fastrtps_cpp::_SmaccState__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, smacc2_msgs, msg, SmaccState)() {
  return &smacc2_msgs::msg::typesupport_fastrtps_cpp::_SmaccState__handle;
}

#ifdef __cplusplus
}
#endif
